Index: code/trunk/src/orxonox/objects/quest/QuestEffectBeacon.cc
===================================================================
--- code/trunk/src/orxonox/objects/quest/QuestEffectBeacon.cc	(revision 2261)
+++ code/trunk/src/orxonox/objects/quest/QuestEffectBeacon.cc	(revision 2261)
@@ -0,0 +1,268 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Damian 'Mozork' Frick
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file QuestEffectBeacon.cc
+    @brief
+    Implementation of the QuestEffectBeacon class.
+*/
+
+#include "OrxonoxStableHeaders.h"
+#include "QuestEffectBeacon.h"
+
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+#include "core/Event.h"
+#include "core/EventIncludes.h"
+
+#include "orxonox/objects/infos/PlayerInfo.h"
+#include "orxonox/objects/worldentities/ControllableEntity.h"
+#include "orxonox/objects/worldentities/triggers/PlayerTrigger.h"
+#include "QuestEffect.h"
+
+namespace orxonox {
+
+    CreateFactory(QuestEffectBeacon);
+
+    /**
+    @brief
+        Constructor. Registers the object and initializes defaults.
+    */
+    QuestEffectBeacon::QuestEffectBeacon(BaseObject* creator) : PositionableEntity(creator)
+    {
+        RegisterObject(QuestEffectBeacon);
+        
+        this->status_ = QuestEffectBeaconStatus::active;
+        this->times_ = INFINITE;
+    }
+
+    /**
+        Destructor.
+    */
+    QuestEffectBeacon::~QuestEffectBeacon()
+    {
+    }
+    
+    /**
+    @brief
+        Method for creating a QuestEffectBeacon object through XML.
+    */
+    void QuestEffectBeacon::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(QuestEffectBeacon, XMLPort, xmlelement, mode);
+
+        XMLPortParam(QuestEffectBeacon, "times", setTimes, getTimes, xmlelement, mode);
+        XMLPortObject(QuestEffectBeacon, QuestEffect, "effects", addEffect, getEffect, xmlelement, mode);
+        
+        COUT(3) << "New QuestEffectBeacon created." << std::endl;
+    }
+    
+    /**
+    @brief
+        Processes an event for this QuestEffectBeacon.
+    */
+    void QuestEffectBeacon::processEvent(Event& event)
+    {
+        SUPER(QuestEffectBeacon, processEvent, event);
+    
+    SetSubclassEvent(QuestEffectBeacon, "execute", execute, event, PlayerTrigger);
+    }
+    
+    /**
+    @brief
+        Executes the QuestEffectBeacon.
+        This means extracting the ControllableEntity from the PlayerTrigger, provided by the Event causing the execution, and the extracting the PlayerInfo from the received ControllableEntity and invoking the QuestEffectbeacon's QuestEffects on the received PlayerInfo.
+    @param trigger
+        Apointer to the PlayerTrigger that threw the Event.
+    @return
+        Returns true if successfully executed, false if not.
+    */
+    bool QuestEffectBeacon::execute(bool b, PlayerTrigger* trigger)
+    {
+        if(!b)
+        {
+            return false;
+        }
+        if(!(this->isActive())) //!< If the QuestEffectBeacon is inactive it cannot be executed.
+        {
+            COUT(3) << "The QuestEffectBeacon is inactive." << std::endl;
+            return false;
+        }
+        
+        if(!trigger->isForPlayer()) //!< The PlayerTrigger is not exclusively for ControllableEntities which means we cannot extract one.
+        {
+            return false;
+        }
+
+        //! Extracting the ControllableEntity form the PlayerTrigger.
+        ControllableEntity* entity = trigger->getTriggeringPlayer();
+
+        if(entity == NULL)
+        {
+            COUT(2) << "The QuestEffectBeacon was triggered by an entity other than a ControllableEntity." << std::endl;
+            return false;
+        }
+        
+        //! Extract the PlayerInfo from the ControllableEntity.
+        PlayerInfo* player = entity->getPlayer();
+        
+        if(player == NULL)
+        {
+            COUT(3) << "The PlayerInfo* is NULL." << std::endl;
+            return false;
+        }
+
+        COUT(3) << "QuestEffectBeacon executed on player: " << player << " ." << std::endl;
+
+        bool check = QuestEffect::invokeEffects(player, this->effects_); //!< Invoke the QuestEffects on the PlayerInfo.
+        if(check)
+        {
+            this->decrementTimes(); //!< Decrement the number of times the beacon can be used.
+            return true;
+    }
+
+    return false;
+    }
+    
+    /**
+    @brief
+        Set the status of the QuestEffectBeacon.
+    @param activate
+        If true the QuestEffectBeacon is activated, if false it is deactivated.
+    @return
+        Returns whether the activation/deactivation was successful.
+    */
+    bool QuestEffectBeacon::setActive(bool activate)
+    {
+        if(this->getTimes() == 0 && activate) //!< A QuestEffectBeacon that can be executed only 0 times is always inactive.
+        {
+            return false;
+        }
+        
+        if(activate)
+        {
+        this->status_ = QuestEffectBeaconStatus::active;
+        return true;
+        }
+        
+        this->status_ = QuestEffectBeaconStatus::inactive;
+        return true;
+    }
+    
+    /**
+    @brief
+        Decrement the number of times the QuestEffectBeacon can be executed.
+    @return
+        Returns true if successful.
+    */
+    bool QuestEffectBeacon::decrementTimes(void)
+    {
+        if(!(this->isActive())) //!< The QuestEffectBeacon mus be active to decrement the number of times it can be executed.
+        {
+            return false;
+        }
+        if(this->getTimes() == INFINITE) //!< If times is infinity the QuestEffectBeacon can be executed an infinite number fo times.
+        {
+            return true;
+        }
+        
+        this->times_ = this->times_ - 1; //!< Decrement number of times the QuestEffectBeacon can be executed.
+    if(this->getTimes() == 0) //!< Set the QuestEffectBeacon to inactive when the number of times it can be executed is reduced to 0.
+    {
+            this->status_ = QuestEffectBeaconStatus::inactive;
+    }
+        
+        return true;
+    }
+    
+    /**
+    @brief
+        Set the number of times the QuestEffectBeacon can be executed.
+        The number must be eighter <= 0, or INFINITY which is '-1'.
+    @param n
+        The number of times the QuestEffectBeacon can be executed.
+        The number must be eighter <= 0, or INFINITY which is '-1'.
+    @return
+        Returns true if successful.
+    */
+    bool QuestEffectBeacon::setTimes(const int & n)
+    {
+        if(n < 0 && n != INFINITE)
+        {
+            return false;
+        }
+        
+        this->times_ = n;
+        return true;
+    }
+    
+    /**
+    @brief
+        Adds a QuestEffect to the QuestEffectBeacon.
+    @param effect
+        A pointer to the QuestEffect to be added.
+    @return
+        Returns true if successful.
+    */
+    bool QuestEffectBeacon::addEffect(QuestEffect* effect)
+    {
+        if(effect == NULL) //!< NULL-pointers are not well liked here...
+        {
+            COUT(2) << "A NULL-QuestEffect was trying to be added" << std::endl;
+            return false;
+        }
+
+        this->effects_.push_back(effect);
+
+        COUT(3) << "A QuestEffect was added to a QuestEffectBeacon." << std::endl;
+        return true;
+    }
+    
+    /**
+    @brief
+        Returns the QuestEffect at the given index.
+    @param index
+        The index.
+    @return
+        Returns a pointer to the QuestEffect at the given index.
+    */
+    const QuestEffect* QuestEffectBeacon::getEffect(unsigned int index) const
+    {
+        int i = index;
+        for (std::list<QuestEffect*>::const_iterator effect = this->effects_.begin(); effect != this->effects_.end(); ++effect)
+        {
+            if(i == 0)
+            {
+               return *effect;
+            }
+            i--;
+        }
+        return NULL;
+    }
+
+}
Index: code/trunk/src/orxonox/objects/quest/QuestEffectBeacon.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/QuestEffectBeacon.h	(revision 2261)
+++ code/trunk/src/orxonox/objects/quest/QuestEffectBeacon.h	(revision 2261)
@@ -0,0 +1,130 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Damian 'Mozork' Frick
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file QuestEffectBeacon.h
+    @brief
+    Definition of the QuestEffectBeacon class.
+*/
+
+#ifndef _QuestEffectBeacon_H__
+#define _QuestEffectBeacon_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "orxonox/objects/worldentities/PositionableEntity.h"
+
+namespace QuestEffectBeaconStatus
+{
+
+    //! The status of the beacon, can be either active or inactive.
+    enum Enum
+    {
+        inactive,
+        active
+    };
+
+}
+
+namespace orxonox {
+
+    /**
+    @brief
+        A QuestEffectBeacon is a physical entity in the game which can (under some condition(s)) invoke a number QuestEffects on players meeting the condition(s).
+        The conditions under which the QuestEffects are invoked on the player are defined by Triggers.
+        A QuestEffectBeacon can be executed a defined number of times.
+        A QuestEffectBeacon can be inactive or active.
+        
+    Creating a QuestEffectBeacon through XML goes as follows:
+    
+    <QuestEffectBeacon times=n> //Where 'n' is eighter a number >= 0, which means the QuestEffectBeacon can be executed n times. Or n = -1, which means the QuestEffectBeacon can be executed an infinite number of times.
+            <effects>
+                <QuestEffect /> //A list of QuestEffects, invoked when the QuestEffectBeacon is executed, see QuestEffect for the full XML representation.
+                ...
+                <QuestEffect />
+            </effects>
+            <events>
+        <execute>
+            <EventListener event=eventIdString />
+        </execute>
+        </events>
+        <attached>
+           <PlayerTrigger name=eventIdString /> //A PlayerTrigger triggering the execution of the QuestEffectBeacon.
+        </attached>
+    </QuestEffectBeacon>
+    @author
+        Damian 'Mozork' Frick
+    */
+    class _OrxonoxExport QuestEffectBeacon : public PositionableEntity
+    {
+    public:
+        QuestEffectBeacon(BaseObject* creator);
+        virtual ~QuestEffectBeacon();
+        
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a QuestEffectBeacon object through XML.
+        
+        virtual void processEvent(Event& event); //!< Processes an event for this QuestEffectBeacon.
+        
+        bool execute(bool b, PlayerTrigger* trigger); //!< Executes the QuestEffects of the QuestEffectBeacon.
+        
+        /**
+        @brief Tests whether the QuestEffectBeacon is active.
+        @return Returns true if the QuestEffectBeacon is active, fals if not.
+        */
+        inline bool isActive(void)
+           { return this->status_ == QuestEffectBeaconStatus::active; }
+        
+        bool setActive(bool activate); //!< Set the status of the QuestEffectBeacon.
+        
+    protected:
+            bool decrementTimes(void); //!< Decrement the number of times the QuestEffectBeacon can still be executed.
+            
+            /**
+            @brief Returns the number of times the QUestEffectBeacon can still be executed.
+            @return Returns the number of times the QUestEffectBeacon can still be executed.
+            */
+            inline const int & getTimes(void) const
+                { return this->times_; }
+
+        private:
+            static const int INFINITE = -1; //!< Constant to avoid using magic numbers.
+        
+            std::list<QuestEffect*> effects_; //!< The list of QuestEffects to be invoked on the executing player.
+            int times_; //!< Number of times the beacon can be exectued.
+            QuestEffectBeaconStatus::Enum status_; //!< The status of the QUestEffectBeacon, Can be eighter active or inactive.
+            
+            bool setTimes(const int & n); //!< Set the number of times the QuestEffectBeacon can be executed.
+            bool addEffect(QuestEffect* effect); //!< Add a QuestEffect to the QuestEffectBeacon.
+            
+            const QuestEffect* getEffect(unsigned int index) const; //!< Get the QuestEffect at a given index.
+    
+    };
+
+}
+
+#endif /* _QuestEffectBeacon_H__ */
Index: code/trunk/src/orxonox/objects/quest/QuestHint.cc
===================================================================
--- code/trunk/src/orxonox/objects/quest/QuestHint.cc	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/QuestHint.cc	(revision 2261)
@@ -26,4 +26,10 @@
  *
  */
+ 
+/**
+    @file QuestHint.cc
+    @brief
+    Implementation of the QuestHint class.
+*/
 
 #include "OrxonoxStableHeaders.h"
@@ -33,4 +39,6 @@
 #include "util/Exception.h"
 
+#include "orxonox/objects/infos/PlayerInfo.h"
+#include "QuestManager.h"
 #include "Quest.h"
 
@@ -41,11 +49,9 @@
     /**
     @brief
-        Constructor.
+        Constructor. Registers the object.
     */
     QuestHint::QuestHint(BaseObject* creator) : QuestItem(creator)
     {
         RegisterObject(QuestHint);
-
-        this->initialize();
     }
 
@@ -59,13 +65,14 @@
     }
 
-    void QuestHint::initialize(void)
-    {
-        RegisterObject(QuestHint);
-    }
-
+    /**
+    @brief
+        Method for creating a QuestHint object through XML.
+    */
     void QuestHint::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
         SUPER(QuestHint, XMLPort, xmlelement, mode);
 
+        QuestManager::registerHint(this); //!< Registers the QuestHint with the QuestManager.
+        
         COUT(3) << "New QuestHint {" << this->getId() << "} created." << std::endl;
     }
@@ -74,5 +81,5 @@
     /**
     @brief
-        Checks whether the hint is active for a specific player.
+        Checks whether the QuestHint is active for a specific player.
     @param player
         The player.
@@ -80,19 +87,21 @@
         Throws an Argument Exception if the input Player-pointer is NULL.
     @return
-        Returns true if the hint is active for the specified player.
+        Returns true if the QuestHint is active for the specified player.
     */
-    bool QuestHint::isActive(Player* player)
+    bool QuestHint::isActive(const PlayerInfo* player) const
     {
-        if(player == NULL)
+        if(player == NULL) //!< NULL-Pointers are ugly!
         {
-            ThrowException(Argument, "The input Player* is NULL.");
+            ThrowException(Argument, "The input PlayerInfo* is NULL.");
             return false;
         }
 
-        std::map<Player*, questHintStatus::Enum>::iterator it = this->playerStatus_.find(player);
-        if (it != this->playerStatus_.end())
+        //! Find the player.
+        std::map<const PlayerInfo*, questHintStatus::Enum>::const_iterator it = this->playerStatus_.find(player);
+        if (it != this->playerStatus_.end()) //!< If the player is in the map.
         {
             return it->second;
         }
+        
         return questStatus::inactive;
     }
@@ -106,9 +115,9 @@
         Returns true if the activation was successful, false if there were problems.
     */
-    bool QuestHint::activate(Player* player)
+    bool QuestHint::setActive(PlayerInfo* player)
     {
-        if(this->quest_->isActive(player))
+        if(this->quest_->isActive(player)) //!< For a hint to get activated the quest must be active.
         {
-            if(!(this->isActive(player)))
+            if(!(this->isActive(player)))  //!< If the hint is already active, activation is pointless.
             {
                 this->playerStatus_[player] = questHintStatus::active;
@@ -121,4 +130,5 @@
             }
         }
+        
         COUT(2) << "A hint of a non-active quest was trying to get activated." << std::endl;
         return false;
@@ -127,11 +137,13 @@
     /**
     @brief
-        Sets the quest the QuestHitn belongs to.
+        Sets the Quest the QuestHint belongs to.
     @param quest
+        The Quest to be set as Quest the QuestHint is attached to.
     @return
+        Returns true if successful.
     */
     bool QuestHint::setQuest(Quest* quest)
     {
-        if(quest == NULL)
+        if(quest == NULL) //!< NULL-Pointer. Again..?
         {
             COUT(2) << "The input Quest* is NULL." << std::endl;
Index: code/trunk/src/orxonox/objects/quest/QuestHint.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/QuestHint.h	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/QuestHint.h	(revision 2261)
@@ -26,4 +26,10 @@
  *
  */
+ 
+/**
+    @file QuestHint.h
+    @brief
+    Definition of the QuestHint class.
+*/
 
 #ifndef _QuestHint_H__
@@ -41,4 +47,5 @@
 {
 
+    //! The status of the hint.
     enum Enum
     {
@@ -52,11 +59,15 @@
 {
 
-    class Player; //Forward declaration, remove when fully integrated into the objecthirarchy.
-
     /**
     @brief
         Represents a hint in the game towards completing a Quest.
-        Consists of title and description in textual form and must belong to a quest.
-        A QuestHit has a defined status (inactive or active, where inactive is default) for each player, which means each QuestHint exists only once for all players, it doesn't belong to a player, it just has different stati for each of them.
+        Consists of title and description (which is stored in a QuestDescription object) in textual form and must belong to a quest.
+        A QuestHint has a defined status (inactive or active, where inactive is default) for each player, which means each a QuestHint exists only once for all players, it doesn't belong to a player, it just has different states for each of them.
+        
+        Creating a QuestHint through XML goes as follows:
+        
+        <QuestHint id="hintId">  //Where hintId is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information
+            <QuestDesctription title="" description="" />
+        </QuestHint>
     @author
         Damian 'Mozork' Frick
@@ -69,21 +80,21 @@
             virtual ~QuestHint();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a QuestHint object through XML.
 
-            bool isActive(Player* player); //!< Returns true if the hint is active for the input player.
+            bool isActive(const PlayerInfo* player) const; //!< Returns true if the QuestHint is active for the input player.
 
-            bool activate(Player* player); //!< Activates the hint for the input player.
+            bool setActive(PlayerInfo* player); //!< Activates the QuestHint for the input player.
+            bool setQuest(Quest* quest); //!< Sets the Quest the QuestHint belongs to.
 
-            bool setQuest(Quest* quest); //!< Sets the quest the hint belongs to.
-
+            /**
+            @brief Returns the Quest the QuestHint is attached to.
+            @return  Returns a pointer to the Quest the QuestHint is attached to.
+            */
             inline Quest* getQuest(void)
                { return this->quest_; }
 
         private:
-
-            void initialize(void);
-
-            Quest* quest_; //!< The quest the hint belongs to.
-            std::map<Player*, questHintStatus::Enum> playerStatus_; //!< List of the status for each player, with the Player-pointer as key.
+            Quest* quest_; //!< The Quest the QuestHint belongs to.
+            std::map<const PlayerInfo*, questHintStatus::Enum> playerStatus_; //!< List of the status for each player, with the Player-pointer as key.
 
     };
Index: code/trunk/src/orxonox/objects/quest/QuestItem.cc
===================================================================
--- code/trunk/src/orxonox/objects/quest/QuestItem.cc	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/QuestItem.cc	(revision 2261)
@@ -26,4 +26,10 @@
  *
  */
+ 
+/**
+    @file QuestItem.cc
+    @brief
+    Implementation of the QuestItem class.
+*/
 
 #include "OrxonoxStableHeaders.h"
@@ -36,9 +42,13 @@
 namespace orxonox {
 
+    /**
+    @brief
+        Constructor. Registers and initializes the object.
+    */
     QuestItem::QuestItem(BaseObject* creator) : BaseObject(creator)
     {
         RegisterObject(QuestItem);
 
-        this->initialize();
+        this->id_ = "";
     }
 
@@ -52,4 +62,8 @@
     }
 
+    /**
+    @brief
+        Method for creating a QuestItem object through XML.
+    */
     void QuestItem::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
@@ -57,39 +71,24 @@
 
         XMLPortParam(QuestItem, "id", setId, getId, xmlelement, mode);
-        //Doesn't getDescription have to be of type getDescription(unsigned int) ?
-        //XMLPortObjectTemplate(QuestItem, QuestDescription, "", setDescription, getDescription, xmlelement, mode, unsigned int);
         XMLPortObject(QuestItem, QuestDescription, "", setDescription, getDescription, xmlelement, mode);
-
     }
-
 
     /**
     @brief
-        Initializes the object.
-        Should be called first in every constructor of this class.
+        Sets the id of the QuestItem.
+    The id must be of GUID form. See 'http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure' for more information.
+    @param id
+        The id to be set.
     */
-    void QuestItem::initialize(void)
-    {
-        RegisterObject(QuestItem);
-
-        this->id_ = "";
-    }
-
     void QuestItem::setId(const std::string & id)
     {
-        if(!isId(id))
+        if(!isId(id)) //!< Checks whether the id is a valid id.
         {
             COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
             return;
         }
+        
         this->id_ = id;
     }
-
-    //const QuestDescription* QuestItem::getDescription(unsigned int index) const //!< Returns the description of the QuestItem.
-    //{
-    //    if(index != 0)
-    //        return NULL;
-    //    return this->description_;
-    //}
 
     /**
Index: code/trunk/src/orxonox/objects/quest/QuestItem.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/QuestItem.h	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/QuestItem.h	(revision 2261)
@@ -26,4 +26,13 @@
  *
  */
+ 
+/**
+    @file QuestItem.h
+    @brief
+    Definition of the QuestItem class.
+    
+    The QuestItem is the parent class of Quest and QuestHint.
+*/
+
 
 #ifndef _QuestItem_H__
@@ -42,5 +51,5 @@
     /**
     @brief
-        Functions as a base class for Quest classes such as Quest or QuestHint.
+        Functions as a base class for quest classes such as Quest or QuestHint.
         Has a unique identifier and a description.
     @author
@@ -54,16 +63,28 @@
             virtual ~QuestItem();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a QuestItem object through XML.
 
-            inline const std::string & getId(void) const //!< Returns the id of this quest.
+            /**
+            @brief Returns the id of this QuestItem.
+        @return Returns the id of the QuestItem.
+            */
+            inline const std::string & getId(void) const
                 { return this->id_; }
-            inline const QuestDescription* getDescription(void) const //!< Returns the description of the QuestItem.
+        /**
+        @brief Returns the QuestDescription of the QuestItem.
+        @return Returns a pointer to the QuestDescription object of the QuestItem.
+        */
+            inline const QuestDescription* getDescription(void) const
                 { return this->description_; }
-            //const QuestDescription* getDescription(unsigned int index) const; //!< Returns the description of the QuestItem.
 
             static bool isId(const std::string & id); //!< Checks whether a given id is valid.
 
         protected:
-            void setId(const std::string & id);
+            void setId(const std::string & id); //!< Sets the id of the QuestItem.
+            
+            /**
+            @brief Sets the description of the QuestItem.
+            @param description The QuestDescription to be set.
+            */
             inline void setDescription(QuestDescription* description)
                 { this->description_ = description; }
@@ -71,7 +92,5 @@
         private:
             std::string id_; //!< Identifier. Should be of GUID form: http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure
-            QuestDescription* description_; //!< The description of the QuestItem.
-
-            void initialize(void); //!< Initializes the object.
+            QuestDescription* description_; //!< The QuestDescription of the QuestItem.
 
     };
